import java.math.BigInteger;
import java.util.ArrayList;


/**
 * 剣クラスです。
 * @author theki
 *
 */
public class Action {
	
	// type定義用　剣リストの並び順と同じ
	public static final int
		ZANGEKI = 0, ANKOKU = 1, SHOUGEKI = 2, KODOKU = 3, MOUDOKU = 4,
		KENGEKI = 5, KAKURAN = 6, GOUTOU = 7, RENGEKI = 8, KAKUJITU = 9,
		ZETTAI = 10, JUGEKI = 11, MAHOU = 12, DEATH = 13, GEKIDO = 14,
		MESSOU = 15, KANETU = 16, KAGO = 17, KASOKU = 18, SYAKUNETU = 19,
		TATE = 20, INOTI = 21, TAMASII = 22, OSHIWAKE = 23, SENKOU = 24,
		KAGAMI = 25, KAIFUKU = 26, KAIYU = 27, GISHIKI = 28, GARYU = 29,
		DOURAI = 30, DOKUYAKU = 31, SHINDOU = 32, GOUKAI = 33, SEISOU = 34;

	// genre定義用（実行種別(補助、制御、追加、攻撃、構築、環境
	public static final int SPT = 0, CTR = 1, ATK = 2, ENV = 3 ;
	
	// 剣の名前
	public static final String[] NAME = {
		"斬撃剣", "闇黒剣", "衝撃剣", "蟲毒剣", "猛毒剣",
		"剣戟剣", "撹乱剣", "強盗剣", "連撃剣", "確実剣",
		"絶対剣", "重撃剣", "魔法剣", "デス剣", "激怒剣",
		"滅奏剣", "加熱剣", "加護剣", "加速剣", "灼熱剣",
		"盾の剣", "命の剣", "魂の剣", "押分剣", "先行剣",
		"鏡の剣", "回復剣", "快癒剣", "儀式剣", "臥竜剣",
		"導来剣", "毒薬剣", "振動剣", "豪快剣", "星霜剣"
	} ;
	
	// 剣の略称
	public static String[] ABBR = {
		"斬", "闇", "衝", "毒", "猛", "戟", "撹", "盗", "連", "確",
		"絶", "重", "魔", "死", "怒", "滅", "熱", "護", "速", "灼",
		"盾", "命", "魂", "押", "先", "鏡", "回", "癒", "儀", "臥",
		"導", "薬", "振", "豪", "星"
	} ;
	// 剣の種類、実行種別
	private int type, genre ;
	// 起動時間、毒与え、スタン与え、連撃回数、破壊伴い
	private int boot, poison, stan, hit, destroy ;
	// リミテッド、全体化、対症、危殆
	private boolean limited, whole, symptom, pinch ;
	// 剣の実行時に対象とする剣師
	private ArrayList<Player> targetPlayers ;
	// 剣の実行時に対象とする剣
	private Action targetAction ;
	// 防護を無視するかどうか
	private boolean ignoreGuard ;
	// 防衛を無視するかどうか
	private boolean ignoreMirror ;
	// 使用中かどうか
	private boolean used ;
	// 遅延起動が設定されている,もしくは変化しているかどうか
	private boolean bootChangeFlag ;
	// スタン/毒与え/リミテッド/全体化が新たに付与されているかどうか
	private boolean stanChangeFlag, poisonChangeFlag, limitedChangeFlag, wholeChangeFlag, pinchChangeFlag ;
	
	public int getType() {
		return type;
	}
	public void setType(int type) {
		this.type = type;
	}
	public int getBoot() {
		return boot;
	}
	public void setBoot(int boot) {
		this.boot = boot;
	}
	public int getPoison() {
		return poison;
	}
	public void setPoison(int poison) {
		this.poison = poison;
	}
	public int getStan() {
		return stan;
	}
	public void setStan(int stan) {
		this.stan = stan;
	}
	public boolean isPinch() {
		return pinch;
	}
	public void setPinch(boolean pinch) {
		this.pinch = pinch;
	}
	public boolean isLimited() {
		return limited;
	}
	public void setLimited(boolean limited) {
		this.limited = limited;
	}
	public boolean isWhole() {
		return whole;
	}
	public void setWhole(boolean whole) {
		this.whole = whole;
	}
	public boolean isSymptom() {
		return symptom;
	}
	public void setSymptom(boolean symptom) {
		this.symptom = symptom;
	}
	public int getGenre() {
		return genre;
	}
	public void setGenre(int genre) {
		this.genre = genre;
	}
	public int getHit() {
		return hit;
	}
	public void setHit(int hit) {
		this.hit = hit;
	}
	public int getDestroy() {
		return destroy;
	}
	public void setDestroy(int destroy) {
		this.destroy = destroy;
	}
	public boolean isIgnoreGuard() {
		return ignoreGuard;
	}
	public void setIgnoreGuard(boolean ignoreGuard) {
		this.ignoreGuard = ignoreGuard;
	}

	public boolean isIgnoreMirror() {
		return ignoreMirror;
	}
	public void setIgnoreMirror(boolean ignoreMirror) {
		this.ignoreMirror = ignoreMirror;
	}

	public boolean isBootChangeFlag() {
		return bootChangeFlag;
	}
	public void setBootChangeFlag(boolean bootChangeFlag) {
		this.bootChangeFlag = bootChangeFlag;
	}

	public boolean isStanChangeFlag() {
		return stanChangeFlag;
	}

	public void setStanChangeFlag(boolean stanChangeFlag) {
		this.stanChangeFlag = stanChangeFlag;
	}

	public boolean isPoisonChangeFlag() {
		return poisonChangeFlag;
	}

	public void setPoisonChangeFlag(boolean poisonChangeFlag) {
		this.poisonChangeFlag = poisonChangeFlag;
	}

	public boolean isLimitedChangeFlag() {
		return limitedChangeFlag;
	}

	public void setLimitedChangeFlag(boolean limitedChangeFlag) {
		this.limitedChangeFlag = limitedChangeFlag;
	}

	public boolean isWholeChangeFlag() {
		return wholeChangeFlag;
	}

	public void setWholeChangeFlag(boolean wholeChangeFlag) {
		this.wholeChangeFlag = wholeChangeFlag;
	}

	public boolean isPinchChangeFlag() {
		return pinchChangeFlag;
	}

	public void setPinchChangeFlag(boolean pinchChangeFlag) {
		this.pinchChangeFlag = pinchChangeFlag;
	}

	public boolean isUsed() {
		return used;
	}
	public void setUsed(boolean used) {
		this.used = used;
	}

	public ArrayList<Player> getTargetPlayers() {
		return targetPlayers;
	}

	public void setTargetPlayers(ArrayList<Player> targetPlayers) {
		this.targetPlayers = targetPlayers;
	}

	public Action getTargetAction() {
		return targetAction;
	}

	public void setTargetAction(Action target) {
		this.targetAction = target;
	}

	/**
	 * コンストラクタ
	 * 文字列actionDataより、剣のインスタンスを生成します。
	 * 
	 * actionDataは、以下の要素から成り立ちます。
	 * 1.剣の略称 ： 剣の名称に含まれる、指定された1文字
	 * 2.遅延起動/ピリオド(遅延剣の場合) : 0~20までの数字
	 * 3.スタン与えn : Sn
	 * 4.毒与えn : Pn
	 * 5.全体化 : W
	 * 6.リミテッド : L
	 * 
	 * 必須の項目は1.のみであり、その他の項目は剣のエンチャントに応じて自由に設定が可能です。
	 * また、1.と2.以外の記述順序は自由です。遅延起動とピリオドは同時に設定できません。
	 * 早期起動については、早期起動を考慮した遅延起動数を設定してください。
	 * 
	 * @param actionData
	 * @throws Exception 
	 */
	public Action( String actionData ) throws Exception{
		// 初期化
		limited = whole = false ;
		type = -1 ;
		pinch = false ;
		poison = stan = 0 ;
		boot = hit = 1 ;
		used = symptom = false ;
		targetAction = null ;
		
		// 剣の決定
		prisetAction( actionData.charAt(0) );
		
		// 遅延起動設定（設定出来る剣かどうかに関わらず、数字が記述されていれば設定
		int i = 0 ;
		int num = Util.getNextNum(actionData, i);
		// 数字が記述されているなら
		if( num != Integer.MAX_VALUE ){
			boot = num ;
			bootChangeFlag = true ;
			i ++ ;
			if( num >= 10 )
				i += Math.log10((int)num);
		}
		i++ ;
		
		// エンチャント設定（記述の順序は自由
		while( i < actionData.length() ){
			char c = actionData.charAt(i);
			// スタン与え
			if( c == 'S' ){
				num = Util.getNextNum(actionData, i);
				if( num != Integer.MAX_VALUE ){
					stan = num ;
					i ++ ;
					if( num >= 10 )
						i += Math.log10((int)num);
				}
				else
					stan = 1 ;
				stanChangeFlag = true ;
				i ++ ;
				continue ;
			}
			// 毒与え
			if( c == 'P' ){
				num = Util.getNextNum(actionData, i);
				if( num != Integer.MAX_VALUE ){
					poison = num ;
					i ++ ;
					if( num >= 10 )
						i += Math.log10((int)num);
				}
				else
					poison = 1 ;
				poisonChangeFlag = true ;
				i ++ ;
				continue ;

			}
			// 破壊伴い
			if( c == 'D' ){
				num = Util.getNextNum(actionData, i);
				if( num != Integer.MAX_VALUE ){
					destroy = num ;
					i ++ ;
					if( num >= 10 )
						i += Math.log10((int)num);
				}
				else
					destroy = 1 ;
				i ++ ;
				continue ;

			}
			// リミテッド
			if( c == 'L' ){
				i ++ ;
				limited = true ;
				limitedChangeFlag = true ;
				continue ;
			}
		}
	}

	/**
	 * 剣の略称である文字cから、剣固有のデータを取得し、設定を保存します。
	 * 設定されるパラメータは、type,genre,mp,hit,ignoreGuard,ignoreMirror,
	 * poison,stan,while,limited,boot,attackerです。
	 * @param c　剣の略称である文字列
	 * @throws Exception 
	 */
	private void prisetAction( char c ) throws Exception{
		for(int i=0;i<ABBR.length;i++){
			if( ABBR[i].charAt(0) == c ){
				type = i ;
				break ;
			}
		}
		if( type == -1 )
			throw new Exception("剣師定義ファイルに、存在しない剣\""+c+"\"が含まれています。");

		// 剣の実行種別
	         if( type <= MESSOU ) genre = ATK ;
	    else if( type <= GARYU ) genre = SPT ;
		else if( type <= GOUKAI ) genre = CTR ;
		else if( type <= SEISOU ) genre = ENV ;
		else genre = -1 ;
		
	    // 遅延起動
		if( type == OSHIWAKE ||type == SENKOU || type == GISHIKI || type == GARYU 
		 || type == DOURAI )
			boot = 0 ;
		else if( type == SHOUGEKI || type == MAHOU || type == KAGAMI || type == GOUTOU || type == ANKOKU
			  || type == ANKOKU || type == MOUDOKU || type == GOUKAI || type == KENGEKI )
			boot = 2 ;
		else if( type == ZETTAI || type == RENGEKI || type == JUGEKI
			  || type == SYAKUNETU || type == TAMASII )
			boot = 3 ;
		else if( type == DEATH )
			boot = 6 ;
		
		
		// リミテッド
		if( type == KODOKU || type == MAHOU || type == DEATH || type == GISHIKI
		 || type == KAGAMI || type == INOTI || type == KAIFUKU || type == MESSOU
		 || type == GEKIDO || type == MOUDOKU || type == KAKURAN  || type == SENKOU 
		 || type == GOUTOU || type == TAMASII || type == OSHIWAKE 
		 || type == GARYU || type == SYAKUNETU || genre == CTR )
			limited = true ;
		
		// 危殆
		if( type == KAIFUKU || type == MESSOU || type == GEKIDO )
			pinch = true ;
		
		// 連撃など
		if( type == RENGEKI ) hit = 2 ;
		else if( type == KODOKU ) poison = 1 ;
		else if( type == SHOUGEKI ) stan = 1 ;
		else if( type == ANKOKU ){
			ignoreGuard = true ;
			ignoreMirror = true ;
		}
		else if( type == KAIYU )
			symptom = true ;
	}
	
	/**
	 * 剣の状態を文字列表現によって返します。
	 * この関数をactionDataとして、Actionのインスタンスを生成することで、
	 * 同等の効果を持った剣のインスタンスを生成することが可能です。
	 * @return
	 */
	public String getStates(){
		String str = ABBR[type] ;
		if(bootChangeFlag)str+=boot;
		if(stan>0 && stanChangeFlag){
			str+="S";
			if( stan >= 2 )
				str += stan;
		}
		if(poison>0 && poisonChangeFlag){
			str+="P";
			if( poison >= 2 )
				str += poison;
		}
		if(destroy>0){
			str+="D";
			if( destroy >= 2 )
				str += destroy;
		}
		if(whole && wholeChangeFlag)str+="W";
		if(limited && limitedChangeFlag)str+="L";
		if(pinch && pinchChangeFlag)str+="D";
		
		return str ;
	}
	
	public String getOptions(){
		String str = "" ;
		if(bootChangeFlag){
			if( boot == 0 )
				str+="＜高速起動＞";
			else
				str+="＜遅延起動"+boot+"＞";

		}
		if(stanChangeFlag){
			str+="＜スタン与え＞";
			if( stan >= 2 )
				str+="*"+stan;
		}
		if(poisonChangeFlag){
			str+="＜毒与え＞";
			if( poison >= 2 )
				str+="*"+poison;
		}
		if(destroy > 0){
			str+="＜破壊伴い＞";
			if( destroy >= 2 )
				str+="*"+destroy;
		}
		if(whole && wholeChangeFlag)
			str+="＜全体化＞";
		if(limited && limitedChangeFlag)
			str+="＜リミテッド＞";
		if(pinch && pinchChangeFlag)
			str+="＜危殆起動＞";
		
		return str ;
	}

	/**
	 * 攻撃系の剣の実行処理です。
	 * ダメージを伴わない攻撃剣についての処理は、additionEffectメソッドによって行われます。
	 * @param Player a　攻撃側剣師
	 * @param Player b　防御側剣師
	 * @return　damage　ダメージ量
	 */
	public BigInteger execAttack( Player a, Player b, int turn ){
		BigInteger damage = BigInteger.ZERO ;
		// ダメージ量の決定
		if( type == JUGEKI )
			damage = a.getAtk().shiftLeft(1).subtract(b.getDef()) ;
		else if( type == MAHOU )
			damage = b.getHp().subtract(b.getHp().shiftRight(1)) ;
		else if( type == ZETTAI )
			damage = a.getAtk() ;
		else if( type == KAKUJITU )
			damage = a.getAtk().shiftRight(1) ;
		else if( type == DEATH )
			damage = b.getHp() ;
		else if( type == MESSOU )
			damage = BigInteger.valueOf((long) Math.pow(2, turn)) ;
		else if( type == GEKIDO )
			damage = a.getMaxHp().subtract(a.getHp()) ;
		else
			damage = a.getAtk().subtract(b.getDef()) ;

		// 防護系
		if( !ignoreGuard && b.getShield() > 0 ){
			Util.outputString("      --"+b.getComment()+",　シールド発動。\n" ,SettingMatch.ResultFileName) ;
			damage = damage.shiftRight(1) ;
			b.addShield(-1);
		}

		return damage ;
	}
	
	/**
	 * 補助系の剣の実行処理です。
	 * @param a　実行者
	 * @param b　対象者
	 * @param turn　現在ターン数
	 */
	public void execSupport( Player a, Player b, int turn ){
		// 基本効果の実行
		if(type==KANETU)
			b.addAtk(BigInteger.ONE);
		else if(type==KAGO)
			b.addDef(BigInteger.ONE);
		else if(type==KASOKU)
			b.addSpd(BigInteger.ONE);
		else if(type==TATE)
			b.addShield(1);
		else if(type==KAGAMI)
			b.addReflection(1);
		else if(type==INOTI)
			b.addLife(1);
		else if(type==KAIFUKU)
			b.healLife( turn ) ;
		else if(type==TAMASII)
			b.addSoul(1);
		else if(type==OSHIWAKE)
			b.addPush(1);
		else if(type==SENKOU)
			b.addQuick(1);
		else if(type==KAIYU){
			b.setDeadly(0);
			b.setSleep(0);
			b.setStan(0);
			b.setPoison(0);
		}
		else if(type==GISHIKI)
			b.setSubAp(b.getSubAp().add(BigInteger.valueOf(3)));
		else if(type==GARYU){
			b.setHp( b.getHp().add(BigInteger.TEN) );
			b.setMaxHp( b.getMaxHp().add(BigInteger.TEN) );
			b.addSleep(1);
		}
		else if(type==SYAKUNETU)
			b.addAtk(b.getAtk());

		b.printStatus(false, true);
	}
	
	/**
	 * 制御系の剣の実行処理です。
	 * @param p　対象者
	 * @throws Exception 
	 */
	public void execControl( Player p ) throws Exception{
		// 制御対象とする剣が事前に決定されていなかった場合、エラー
		if( targetAction == null ){
			Util.outputString("      --"+p.getComment()+"には制御できる剣がない。 \n" ,SettingMatch.ResultFileName );
			return ;
		}
		
		// 導来剣
		if( type == DOURAI ){
			if( targetAction.getBoot() != 0 ){
				targetAction.setBoot( targetAction.getBoot()-1 );
				targetAction.setBootChangeFlag(true);
			}
		}
		// 振動剣
		else if( type == SHINDOU && targetAction.getGenre() == ATK ){
			targetAction.setStan( targetAction.getStan()+1 );
			targetAction.setStanChangeFlag(true);
		}
		// 毒薬剣
		else if( type == DOKUYAKU && targetAction.getGenre() == ATK ){
			targetAction.setPoison( targetAction.getPoison()+1 );
			targetAction.setPoisonChangeFlag(true);
		}
		// 豪快剣
		else if( type == GOUKAI && targetAction.getGenre() == ATK ){
			targetAction.setDestroy( targetAction.getDestroy()+1 );
		}
		p.printStatus(false, true);
	}


	/**
	 * 構築・環境系の剣の実行処理です。
	 * @param p　対象者
	 * @param party　対象者のパーティ
	 * @param eParty 対象者の敵軍のパーティ
	 * @param turn　現在のターン数
	 * @throws Exception 
	 */
	public int execBuildAndEnv( Player p, Party party, Party eParty, int turn ) throws Exception{
		// 星霜剣
		if( genre == ENV ){
			Util.outputString("--turn:"+(turn+1)+"\n" ,SettingMatch.ResultFileName);
			return turn + 1;
		}
		
		return turn ;
	}

	/**
	 * 「さらに」の効果です。
	 * @param ap　実行者
	 * @param bp　対象者
	 * @param damage　その剣によるダメージ量
	 * @param turn　ターン数
	 */
	public void additionEffect( Player a, Player b, Action ba, BigInteger damage, int turn ){
		
		// ダメージ追加効果
		if( damage.compareTo(BigInteger.ZERO) > 0 ){
			if(stan>0){
				Util.outputString("      --"+b.getComment()+", スタン" ,SettingMatch.ResultFileName);
				if( stan >= 2 )
					Util.outputString("*"+stan ,SettingMatch.ResultFileName);
				Util.outputString("付与。 \n" ,SettingMatch.ResultFileName);
				b.addStan(stan);
			}
			if(poison>0){
				Util.outputString("      --"+b.getComment()+", 毒" ,SettingMatch.ResultFileName);
				if( poison >= 2 )
					Util.outputString("*"+poison ,SettingMatch.ResultFileName);
				Util.outputString("付与。 \n" ,SettingMatch.ResultFileName);
				b.addPoison(poison);
			}
			if( type == MOUDOKU ){
				Util.outputString("      --"+b.getComment()+", 猛毒付与。\n" ,SettingMatch.ResultFileName);
				b.addDeadly(1);
			}
			else if( type == KAKURAN && b.getActions().size() > 0 ){
				ArrayList<Action> newActions = new ArrayList<Action>();
				for(int i=0;i<b.getActions().size();i++){
					newActions.add( b.getActions().get( b.getActions().size()-i-1 )) ;
				}
				b.setActions( newActions ) ;
				Util.outputString("      --"+b.getComment()+"の剣を撹乱。\n" ,SettingMatch.ResultFileName);
			}
			for( int i =0;i<destroy;i++){
				if( b.getActions().size() > 0 ){
					Action action = b.getActions().get(0);
					b.getActions().remove(0);
					Util.outputString("      --"+b.getComment()+"の"+Action.NAME[action.getType()]+"を破壊。\n" ,SettingMatch.ResultFileName);
				}
			}
			if( type == KENGEKI&& b.getActions().size() > 0 ){
				Action action = null ;
				for(int i=0;i<b.getActions().size();i++){
					action = b.getActions().get(i);
					if( !action.isUsed() )
						break ;
				}
				if( action != null ){
					action.setUsed(true);
					Util.outputString("      --"+b.getComment()+"の"+Action.NAME[action.getType()]+"を使用済みに。 \n" ,SettingMatch.ResultFileName);
				}
			}
			b.printStatus(false, true);
		}
	}

	/**
	 * 「そして」の効果です。
	 * 強盗剣を使用した時のみ、奪う剣を返します。強盗剣以外を使用したとき、nullが返ります。
	 * @param ap　実行者
	 * @param bp　対象者
	 * @param damage その剣が与えるダメージ量
	 * @param turn 現在のターン数
	 */
	public Action optionEffect(Player ap, Player bp, BigInteger damage,int turn) {
		if( damage.compareTo(BigInteger.ZERO) > 0 && type == GOUTOU && bp.getActions().size() > 0 ){
			return bp.getActions().get(0);
		}
		return null ;

	}

	/**
	 * ：「／」で区切られた効果です。
	 * @param p 実行者
	 * @param action　その剣の実行時のtype（同時行動により変化している可能性があるため
	 * @param turn　現在のターン数
	 */
	public void secondEffect(Player p, Action action, int turn) {
		int oldType = action.getType() ;
	}

}
